package net.mc_pandacraft.java.plugin.pandacraftutils.login_message;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import net.mc_pandacraft.java.plugin.pandacraftutils.PandacraftUtils;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

import de.luricos.bukkit.xAuth.events.xAuthLoginEvent;

public class LoginLogoutManager implements Listener {

	private PandacraftUtils plugin;
	
	private List<Player> loggedInPlayer = new ArrayList<Player>();
	
	
	public LoginLogoutManager(PandacraftUtils pl) {
		plugin = pl;
		
		plugin.getServer().getPluginManager().registerEvents(this, plugin);
	}
	
	
	@EventHandler
	public void onPlayerJoin(PlayerJoinEvent event) {
		event.setJoinMessage(null);
	}
	
	
	@EventHandler
	public void onxAuthLogin(xAuthLoginEvent event) {
		plugin.getServer().broadcastMessage(ChatColor.YELLOW+event.getPlayer().getDisplayName()+ChatColor.YELLOW+" vient de se connecter");
		loggedInPlayer.add(event.getPlayer());
	}
	
	@EventHandler
	public void onPlayerQuit(PlayerQuitEvent event) {
		event.setQuitMessage(null);
		
		if (!isPlayerLoggedIn(event.getPlayer()))
			return;
		loggedInPlayer.remove(event.getPlayer());
		event.setQuitMessage(ChatColor.YELLOW+event.getPlayer().getDisplayName()+ChatColor.YELLOW+" a quitté le jeu");
	}
	
	
	public List<Player> getLoggedInPlayer() { return loggedInPlayer; }
	
	public List<Player> getLoggedOutPlayer() {
		List<Player> players = new ArrayList<Player>(Arrays.asList(plugin.getServer().getOnlinePlayers()));
		players.removeAll(loggedInPlayer);
		return players;
	}
	
	public boolean isPlayerLoggedIn(Player p) {
		return loggedInPlayer.contains(p);
	}
	
}
